//	EBhEJ(ggp)
//	Visual C++ 2013 32/64bit

#include <windows.h>
#include <tchar.h>

TCHAR szClassName[] = TEXT("TestWindow");

#ifdef _WIN64
	typedef LONG_PTR WINDOW_LONG_PTR;
#else
	typedef LONG WINDOW_LONG_PTR;
#endif

	//	EBhEvV[W[
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

//	EBhE쐬
BOOL InitInstance(HINSTANCE hInst, TCHAR* szClassName, int nCmdShow, LPVOID para);

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInst, TCHAR* lpszCmdLine, int nCmdShow){
	MSG lpMsg;
	WNDCLASS wc;

	if (!hPreInst) {
		wc.style = CS_HREDRAW | CS_VREDRAW;
		wc.lpfnWndProc = WndProc;
		wc.cbClsExtra = 0;
		wc.cbWndExtra = sizeof(WINDOW_LONG_PTR);
		wc.hInstance = hInstance;
		wc.hIcon = NULL;
		wc.hCursor = LoadCursor(NULL, IDC_ARROW);
		wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
		wc.lpszMenuName = NULL;
		wc.lpszClassName = szClassName;
		if (!RegisterClass(&wc))
			return FALSE;
	}
	if (!InitInstance(hInstance, szClassName, nCmdShow, TEXT("1ڂ̃EBhEł"))) {    // EBhE̍쐬
		return FALSE;
	}
	if (!InitInstance(hInstance, szClassName, nCmdShow, TEXT("2ڂ̃EBhEł"))) {    // EBhE̍쐬
		return FALSE;
	}

	while (GetMessage(&lpMsg, NULL, 0, 0)) {
		TranslateMessage(&lpMsg);
		DispatchMessage(&lpMsg);
	}
	return int(lpMsg.wParam);
}

//	EBhEvV[W[

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	HDC hdc;
	PAINTSTRUCT ps;

	switch (msg) {
	case WM_CREATE:{
		CREATESTRUCT* cp;
		cp = (CREATESTRUCT*)lParam;
		SetWindowLongPtr(hWnd, 0, (WINDOW_LONG_PTR)cp->lpCreateParams);
		break;
	}
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	case WM_PAINT:{
		hdc = BeginPaint(hWnd, &ps);
		TCHAR* buf = (TCHAR*)GetWindowLongPtr(hWnd, 0);
		TextOut(hdc, 0, 0, buf, (int)_tcslen(buf));
		EndPaint(hWnd, &ps);
		break;
	}
	default:
		return(DefWindowProc(hWnd, msg, wParam, lParam));
	}
	return (0L);
}

//	EBhE쐬
BOOL InitInstance(HINSTANCE hInst, TCHAR* szClassName, int nCmdShow,LPVOID para){
	HWND hWnd = CreateWindow(szClassName,
		_TEXT("^Cg"),
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL,
		NULL,
		hInst,
		(LPVOID)para);
	if (!hWnd)
		return FALSE;
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	return TRUE;
}
